
_advanced_eeprom_test:

;I2C_Advanced.mbas,56 :: 		dim iStr, oStr as string[16]
;I2C_Advanced.mbas,59 :: 		for x = 0 to 63
	CLRF        advanced_eeprom_test_x+0 
L__advanced_eeprom_test2:
;I2C_Advanced.mbas,60 :: 		ByteToHex(x,oStr)
	MOVF        advanced_eeprom_test_x+0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       advanced_eeprom_test_oStr+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(advanced_eeprom_test_oStr+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
;I2C_Advanced.mbas,61 :: 		iStr = ""
	CLRF        advanced_eeprom_test_iStr+0 
;I2C_Advanced.mbas,62 :: 		while length(iStr) < 16
L__advanced_eeprom_test7:
	MOVLW       advanced_eeprom_test_iStr+0
	MOVWF       FARG_Length_Text+0 
	MOVLW       hi_addr(advanced_eeprom_test_iStr+0)
	MOVWF       FARG_Length_Text+1 
	CALL        _Length+0, 0
	MOVLW       0
	SUBWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__advanced_eeprom_test45
	MOVLW       16
	SUBWF       R0, 0 
L__advanced_eeprom_test45:
	BTFSC       STATUS+0, 0 
	GOTO        L__advanced_eeprom_test8
;I2C_Advanced.mbas,63 :: 		iStr = iStr + oStr
	MOVLW       advanced_eeprom_test_iStr+0
	MOVWF       FSR1 
	MOVLW       hi_addr(advanced_eeprom_test_iStr+0)
	MOVWF       FSR1H 
	CALL        ___FZinS+0, 0
	MOVLW       advanced_eeprom_test_oStr+0
	MOVWF       FSR2 
	MOVLW       hi_addr(advanced_eeprom_test_oStr+0)
	MOVWF       FSR2H 
	CALL        ___CS2S+0, 0
	CLRF        POSTINC1+0 
;I2C_Advanced.mbas,64 :: 		wend
	GOTO        L__advanced_eeprom_test7
L__advanced_eeprom_test8:
;I2C_Advanced.mbas,65 :: 		iStr[16] = 0
	CLRF        advanced_eeprom_test_iStr+16 
;I2C_Advanced.mbas,66 :: 		counter = 0
	CLRF        advanced_eeprom_test_counter+0 
;I2C_Advanced.mbas,67 :: 		tmpData = iStr[counter]
	MOVLW       advanced_eeprom_test_iStr+0
	MOVWF       FSR0 
	MOVLW       hi_addr(advanced_eeprom_test_iStr+0)
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       advanced_eeprom_test_tmpdata+0 
;I2C_Advanced.mbas,68 :: 		while (tmpData <> 0)
L__advanced_eeprom_test12:
	MOVF        advanced_eeprom_test_tmpdata+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__advanced_eeprom_test13
;I2C_Advanced.mbas,69 :: 		I2C_EEPROM_WrSingle(counter + (x * 16), tmpdata)   ' writes data, char by char, in the EEPROM
	MOVLW       4
	MOVWF       R2 
	MOVF        advanced_eeprom_test_x+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        R2, 0 
L__advanced_eeprom_test46:
	BZ          L__advanced_eeprom_test47
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	ADDLW       255
	GOTO        L__advanced_eeprom_test46
L__advanced_eeprom_test47:
	MOVF        advanced_eeprom_test_counter+0, 0 
	ADDWF       R0, 0 
	MOVWF       FARG_I2C_EEPROM_WrSingle_wAddr+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FARG_I2C_EEPROM_WrSingle_wAddr+1 
	MOVF        advanced_eeprom_test_tmpdata+0, 0 
	MOVWF       FARG_I2C_EEPROM_WrSingle_wData+0 
	CALL        _I2C_EEPROM_WrSingle+0, 0
;I2C_Advanced.mbas,70 :: 		Inc(counter)
	INCF        advanced_eeprom_test_counter+0, 1 
;I2C_Advanced.mbas,71 :: 		I2C_EEPROM_IdleWait
	CALL        _I2C_EEPROM_IdleWait+0, 0
;I2C_Advanced.mbas,72 :: 		LCD_Chr(1, counter, tmpData)              ' displays data on the first row of the Lcd
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_Row+0 
	MOVF        advanced_eeprom_test_counter+0, 0 
	MOVWF       FARG_Lcd_Chr_Column+0 
	MOVF        advanced_eeprom_test_tmpdata+0, 0 
	MOVWF       FARG_Lcd_Chr_Out_Char+0 
	CALL        _Lcd_Chr+0, 0
;I2C_Advanced.mbas,73 :: 		tmpData = iStr[counter]
	MOVLW       advanced_eeprom_test_iStr+0
	MOVWF       R0 
	MOVLW       hi_addr(advanced_eeprom_test_iStr+0)
	MOVWF       R1 
	MOVF        advanced_eeprom_test_counter+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       advanced_eeprom_test_tmpdata+0 
;I2C_Advanced.mbas,74 :: 		wend
	GOTO        L__advanced_eeprom_test12
L__advanced_eeprom_test13:
;I2C_Advanced.mbas,75 :: 		next x
	MOVF        advanced_eeprom_test_x+0, 0 
	XORLW       63
	BTFSC       STATUS+0, 2 
	GOTO        L__advanced_eeprom_test5
	INCF        advanced_eeprom_test_x+0, 1 
	GOTO        L__advanced_eeprom_test2
L__advanced_eeprom_test5:
;I2C_Advanced.mbas,78 :: 		for x = 43 to 53
	MOVLW       43
	MOVWF       advanced_eeprom_test_x+0 
L__advanced_eeprom_test17:
;I2C_Advanced.mbas,79 :: 		for y = 0 to 15
	CLRF        advanced_eeprom_test_y+0 
L__advanced_eeprom_test22:
;I2C_Advanced.mbas,80 :: 		tmpdata = I2C_EEPROM_RdSingle(x*16+y)
	MOVLW       4
	MOVWF       R0 
	MOVF        advanced_eeprom_test_x+0, 0 
	MOVWF       FARG_I2C_EEPROM_RdSingle_rAddr+0 
	MOVLW       0
	MOVWF       FARG_I2C_EEPROM_RdSingle_rAddr+1 
	MOVF        R0, 0 
L__advanced_eeprom_test48:
	BZ          L__advanced_eeprom_test49
	RLCF        FARG_I2C_EEPROM_RdSingle_rAddr+0, 1 
	BCF         FARG_I2C_EEPROM_RdSingle_rAddr+0, 0 
	RLCF        FARG_I2C_EEPROM_RdSingle_rAddr+1, 1 
	ADDLW       255
	GOTO        L__advanced_eeprom_test48
L__advanced_eeprom_test49:
	MOVF        advanced_eeprom_test_y+0, 0 
	ADDWF       FARG_I2C_EEPROM_RdSingle_rAddr+0, 1 
	MOVLW       0
	ADDWFC      FARG_I2C_EEPROM_RdSingle_rAddr+1, 1 
	CALL        _I2C_EEPROM_RdSingle+0, 0
	MOVF        R0, 0 
	MOVWF       advanced_eeprom_test_tmpdata+0 
;I2C_Advanced.mbas,81 :: 		lcd_chr(2,y+1,tmpdata)
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_Row+0 
	MOVF        advanced_eeprom_test_y+0, 0 
	ADDLW       1
	MOVWF       FARG_Lcd_Chr_Column+0 
	MOVF        R0, 0 
	MOVWF       FARG_Lcd_Chr_Out_Char+0 
	CALL        _Lcd_Chr+0, 0
;I2C_Advanced.mbas,82 :: 		next y
	MOVF        advanced_eeprom_test_y+0, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L__advanced_eeprom_test25
	INCF        advanced_eeprom_test_y+0, 1 
	GOTO        L__advanced_eeprom_test22
L__advanced_eeprom_test25:
;I2C_Advanced.mbas,84 :: 		next x
	MOVF        advanced_eeprom_test_x+0, 0 
	XORLW       53
	BTFSC       STATUS+0, 2 
	GOTO        L__advanced_eeprom_test20
	INCF        advanced_eeprom_test_x+0, 1 
	GOTO        L__advanced_eeprom_test17
L__advanced_eeprom_test20:
;I2C_Advanced.mbas,85 :: 		vdelay_ms(2000)
	MOVLW       208
	MOVWF       FARG_VDelay_ms_Time_ms+0 
	MOVLW       7
	MOVWF       FARG_VDelay_ms_Time_ms+1 
	CALL        _VDelay_ms+0, 0
;I2C_Advanced.mbas,88 :: 		for x = 53 to 63
	MOVLW       53
	MOVWF       advanced_eeprom_test_x+0 
L__advanced_eeprom_test27:
;I2C_Advanced.mbas,89 :: 		I2C_EEPROM_RdSeq(x*16, oStr, 16)
	MOVLW       4
	MOVWF       R0 
	MOVF        advanced_eeprom_test_x+0, 0 
	MOVWF       FARG_I2C_EEPROM_RdSeq_rAddr+0 
	MOVLW       0
	MOVWF       FARG_I2C_EEPROM_RdSeq_rAddr+1 
	MOVF        R0, 0 
L__advanced_eeprom_test50:
	BZ          L__advanced_eeprom_test51
	RLCF        FARG_I2C_EEPROM_RdSeq_rAddr+0, 1 
	BCF         FARG_I2C_EEPROM_RdSeq_rAddr+0, 0 
	RLCF        FARG_I2C_EEPROM_RdSeq_rAddr+1, 1 
	ADDLW       255
	GOTO        L__advanced_eeprom_test50
L__advanced_eeprom_test51:
	MOVLW       advanced_eeprom_test_oStr+0
	MOVWF       FARG_I2C_EEPROM_RdSeq_rdData+0 
	MOVLW       hi_addr(advanced_eeprom_test_oStr+0)
	MOVWF       FARG_I2C_EEPROM_RdSeq_rdData+1 
	MOVLW       16
	MOVWF       FARG_I2C_EEPROM_RdSeq_rLen+0 
	CALL        _I2C_EEPROM_RdSeq+0, 0
;I2C_Advanced.mbas,90 :: 		oStr[16] = 0
	CLRF        advanced_eeprom_test_oStr+16 
;I2C_Advanced.mbas,91 :: 		Lcd_Out(2,1,oStr)
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       advanced_eeprom_test_oStr+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(advanced_eeprom_test_oStr+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;I2C_Advanced.mbas,93 :: 		next x
	MOVF        advanced_eeprom_test_x+0, 0 
	XORLW       63
	BTFSC       STATUS+0, 2 
	GOTO        L__advanced_eeprom_test30
	INCF        advanced_eeprom_test_x+0, 1 
	GOTO        L__advanced_eeprom_test27
L__advanced_eeprom_test30:
;I2C_Advanced.mbas,95 :: 		end sub
L_end_advanced_eeprom_test:
	RETURN      0
; end of _advanced_eeprom_test

_main:

;I2C_Advanced.mbas,102 :: 		counter, tmpdata as byte
;I2C_Advanced.mbas,104 :: 		ANSELA = 0                        ' Configure PORTA pins as digital
	CLRF        ANSELA+0 
;I2C_Advanced.mbas,105 :: 		ANSELB = 0                        ' Configure PORTB pins as digital
	CLRF        ANSELB+0 
;I2C_Advanced.mbas,106 :: 		ANSELC = 0                        ' Configure PORTC pins as digital
	CLRF        ANSELC+0 
;I2C_Advanced.mbas,107 :: 		TRISA = 0                         ' Set PORTA as output
	CLRF        TRISA+0 
;I2C_Advanced.mbas,108 :: 		LATA = 0                          ' Clear PORTA output
	CLRF        LATA+0 
;I2C_Advanced.mbas,109 :: 		I2C_EEPROM_Init()               ' performs TWI initialization
	CALL        _I2C_EEPROM_Init+0, 0
;I2C_Advanced.mbas,110 :: 		Lcd_Init()                        ' performs Lcd initialization
	CALL        _Lcd_Init+0, 0
;I2C_Advanced.mbas,111 :: 		Lcd_Cmd(_LCD_CLEAR)               ' clear Lcd
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;I2C_Advanced.mbas,112 :: 		Lcd_Cmd(_LCD_CURSOR_OFF)          ' set cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;I2C_Advanced.mbas,113 :: 		someData = "I2C mikroE"           ' data to be written
	MOVLW       73
	MOVWF       main_someData+0 
	MOVLW       50
	MOVWF       main_someData+1 
	MOVLW       67
	MOVWF       main_someData+2 
	MOVLW       32
	MOVWF       main_someData+3 
	MOVLW       109
	MOVWF       main_someData+4 
	MOVLW       105
	MOVWF       main_someData+5 
	MOVLW       107
	MOVWF       main_someData+6 
	MOVLW       114
	MOVWF       main_someData+7 
	MOVLW       111
	MOVWF       main_someData+8 
	MOVLW       69
	MOVWF       main_someData+9 
	CLRF        main_someData+10 
;I2C_Advanced.mbas,115 :: 		I2C_EEPROM_BadWrRd()            ' demonstrates I2C SetTimeoutCallback error feedback
	CALL        _I2C_EEPROM_BadWrRd+0, 0
;I2C_Advanced.mbas,118 :: 		counter = 0
	CLRF        main_counter+0 
;I2C_Advanced.mbas,119 :: 		tmpData = someData[counter]
	MOVLW       main_someData+0
	MOVWF       FSR0 
	MOVLW       hi_addr(main_someData+0)
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       main_tmpdata+0 
;I2C_Advanced.mbas,120 :: 		while (tmpData <> 0)
L__main33:
	MOVF        main_tmpdata+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__main34
;I2C_Advanced.mbas,121 :: 		I2C_EEPROM_WrSingle(counter, tmpdata)   ' writes data, char by char, in the EEPROM
	MOVF        main_counter+0, 0 
	MOVWF       FARG_I2C_EEPROM_WrSingle_wAddr+0 
	MOVLW       0
	MOVWF       FARG_I2C_EEPROM_WrSingle_wAddr+1 
	MOVF        main_tmpdata+0, 0 
	MOVWF       FARG_I2C_EEPROM_WrSingle_wData+0 
	CALL        _I2C_EEPROM_WrSingle+0, 0
;I2C_Advanced.mbas,122 :: 		Inc(counter)
	INCF        main_counter+0, 1 
;I2C_Advanced.mbas,124 :: 		LCD_Chr(1, counter, tmpData)              ' displays data on the first row of the Lcd
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_Row+0 
	MOVF        main_counter+0, 0 
	MOVWF       FARG_Lcd_Chr_Column+0 
	MOVF        main_tmpdata+0, 0 
	MOVWF       FARG_Lcd_Chr_Out_Char+0 
	CALL        _Lcd_Chr+0, 0
;I2C_Advanced.mbas,125 :: 		tmpData = someData[counter]
	MOVLW       main_someData+0
	MOVWF       R0 
	MOVLW       hi_addr(main_someData+0)
	MOVWF       R1 
	MOVF        main_counter+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       main_tmpdata+0 
;I2C_Advanced.mbas,126 :: 		wend
	GOTO        L__main33
L__main34:
;I2C_Advanced.mbas,127 :: 		I2C_EEPROM_WrSingle(counter, 0)         ' writes string termination
	MOVF        main_counter+0, 0 
	MOVWF       FARG_I2C_EEPROM_WrSingle_wAddr+0 
	MOVLW       0
	MOVWF       FARG_I2C_EEPROM_WrSingle_wAddr+1 
	CLRF        FARG_I2C_EEPROM_WrSingle_wData+0 
	CALL        _I2C_EEPROM_WrSingle+0, 0
;I2C_Advanced.mbas,128 :: 		I2C_EEPROM_IdleWait()
	CALL        _I2C_EEPROM_IdleWait+0, 0
;I2C_Advanced.mbas,129 :: 		delay_ms(20)
	MOVLW       208
	MOVWF       R12, 0
	MOVLW       201
	MOVWF       R13, 0
L__main37:
	DECFSZ      R13, 1, 1
	BRA         L__main37
	DECFSZ      R12, 1, 1
	BRA         L__main37
	NOP
	NOP
;I2C_Advanced.mbas,131 :: 		counter = 0
	CLRF        main_counter+0 
;I2C_Advanced.mbas,132 :: 		tmpData = I2C_EEPROM_RdSingle(counter)
	CLRF        FARG_I2C_EEPROM_RdSingle_rAddr+0 
	CLRF        FARG_I2C_EEPROM_RdSingle_rAddr+1 
	CALL        _I2C_EEPROM_RdSingle+0, 0
	MOVF        R0, 0 
	MOVWF       main_tmpdata+0 
;I2C_Advanced.mbas,133 :: 		while (tmpData <> 0)
L__main39:
	MOVF        main_tmpdata+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__main40
;I2C_Advanced.mbas,134 :: 		Inc(counter)
	INCF        main_counter+0, 1 
;I2C_Advanced.mbas,135 :: 		LCD_Chr(2, counter, tmpData)              ' displays data from EEPROM on the second row of the Lcd
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_Row+0 
	MOVF        main_counter+0, 0 
	MOVWF       FARG_Lcd_Chr_Column+0 
	MOVF        main_tmpdata+0, 0 
	MOVWF       FARG_Lcd_Chr_Out_Char+0 
	CALL        _Lcd_Chr+0, 0
;I2C_Advanced.mbas,136 :: 		I2C_EEPROM_IdleWait()
	CALL        _I2C_EEPROM_IdleWait+0, 0
;I2C_Advanced.mbas,137 :: 		tmpData = I2C_EEPROM_RdSingle(counter)
	MOVF        main_counter+0, 0 
	MOVWF       FARG_I2C_EEPROM_RdSingle_rAddr+0 
	MOVLW       0
	MOVWF       FARG_I2C_EEPROM_RdSingle_rAddr+1 
	CALL        _I2C_EEPROM_RdSingle+0, 0
	MOVF        R0, 0 
	MOVWF       main_tmpdata+0 
;I2C_Advanced.mbas,138 :: 		wend
	GOTO        L__main39
L__main40:
;I2C_Advanced.mbas,146 :: 		delay_ms(2000)
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L__main43:
	DECFSZ      R13, 1, 1
	BRA         L__main43
	DECFSZ      R12, 1, 1
	BRA         L__main43
	DECFSZ      R11, 1, 1
	BRA         L__main43
	NOP
;I2C_Advanced.mbas,147 :: 		Lcd_Cmd(_LCD_CLEAR)
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;I2C_Advanced.mbas,148 :: 		advanced_eeprom_test()        ' accesses high memory - won't work right on 24C02, will work with 24C08
	CALL        _advanced_eeprom_test+0, 0
L_end_main:
	GOTO        $+0
; end of _main
